	* 68000 exception vector code for
	* Theo Markettos' Home Automation System
	* 
	* This code is copyright Theo Markettos 1997,
	* and may be freely distributed, with the proviso
	* that it is used for educational and non-profit
	* making purposes only
	* 
	* If you have any problems using this code, you
	* should contact the author at
	* theomarkettos@letterbox.com
 

	ORG	$0
	DC.L	$44000			* full descending supervisor stack
					* pointer
	DC.L	start			* code address to call

	DC.L	$108			* exception vector table
	DC.L	$10C			* - all point to routine to set
	DC.L	$110			* D0 to vector number then flash
	DC.L	$114			* it on the LEDs
	DC.L	$118
	DC.L	$11C
	DC.L	$120
	DC.L	$124
	DC.L	$128
	DC.L	$12C
	DC.L	$130
	DC.L	$134
	DC.L	$138
	DC.L	$13C
	DC.L	$140
	DC.L	$144
	DC.L	$148
	DC.L	$14C
	DC.L	$150
	DC.L	$154
	DC.L	$158
	DC.L	$15C
	DC.L	$160
	DC.L	$164
	DC.L	$168
	DC.L	$16C
	DC.L	$170
	DC.L	$174
	DC.L	$178
	DC.L	$17C
trap0vector
	DC.L	trap0                   * TRAP #0 handler - OS routines
	DC.L	trap			* Simple trap handler - just return
	DC.L	trap
	DC.L	trap
	DC.L	trap
	DC.L	trap
	DC.L	trap
	DC.L	trap
	DC.L	trap
	DC.L	trap
	DC.L	trap
	DC.L	trap
	DC.L	trap
	DC.L	trap
	DC.L	trap
trap15vector
	DC.L	trap15			* TRAP #15 handler - hardware accesses

        ORG	$108			* code to set D0 to exception
	MOVEQ	#$8,D0			* vector number as pointed to above
	BRA.S	exception
	MOVEQ	#$C,D0
	BRA.S	exception
	MOVEQ	#$10,D0
	BRA.S	exception
	MOVEQ	#$14,D0
	BRA.S	exception
	MOVEQ	#$18,D0
	BRA.S	exception
	MOVEQ	#$1C,D0
	BRA.S	exception
	MOVEQ	#$20,D0
	BRA.S	exception
	MOVEQ	#$24,D0
	BRA.S	exception
	MOVEQ	#$28,D0
	BRA.S	exception
	MOVEQ	#$2C,D0
	BRA.S	exception
	MOVEQ	#$30,D0
	BRA.S	exception
	MOVEQ	#$34,D0
	BRA.S	exception
	MOVEQ	#$38,D0
	BRA.S	exception
	MOVEQ	#$3C,D0
	BRA.S	exception
	MOVEQ	#$40,D0
	BRA.S	exception
	MOVEQ	#$44,D0
	BRA.S	exception
	MOVEQ	#$48,D0
	BRA.S	exception
	MOVEQ	#$4C,D0
	BRA.S	exception
	MOVEQ	#$50,D0
	BRA.S	exception
	MOVEQ	#$54,D0
	BRA.S	exception
	MOVEQ	#$58,D0
	BRA.S	exception
	MOVEQ	#$5C,D0
	BRA.S	exception
	MOVEQ	#$60,D0
	BRA.S	exception
	MOVEQ	#$64,D0
	BRA.S	exception
	MOVEQ	#$68,D0
	BRA.S	exception
	MOVEQ	#$6C,D0
	BRA.S	exception
	MOVEQ	#$70,D0
	BRA.S	exception
	MOVEQ	#$74,D0
	BRA.S	exception
	MOVEQ	#$78,D0
	BRA.S	exception
	MOVEQ	#$7C,D0
	NOP				* Should be at $180 by now

	ORG	$180
exception
	MOVE	#$2600,SR		* Only allow NMI
	*MOVE.B	#5,SER_BPS		* Select clock frequency - in
					* 64 mode, 5 = 9600 bps
	*MOVE.B	#3,ACIA_CR		* Initialise 6850
	*MOVE.B	#$56,ACIA_CR		* Set 64, 8 bits, no parity,
					* 1 stop bit, disable receive IRQs

	*MOVEQ	#15,D2			* only send six serial bytes
	MOVE.B	D0,D4			* preserve exception no.
	MOVE.B	D0,DOUT_H		* write exception code on high LEDs
	MOVE.B	#-1,D0			* initial value to store on low LEDs
excep_loop
	MOVE.B	D0,DOUT_L		* store on low LEDs
	NOT	D0			* invert D0
	MOVE.W	#$FFFF,D1		* loop variable
	*CMP	#0,D2			* if D2 is zero, skip next bit
	*BNE	excep_serial_send	* if not send serial
					* byte
excep_time_loop
	DBF	D1,excep_time_loop	* decrement and loop (waste time)

	BRA.S	excep_loop

excep_serial_send
	SUB	#1,D2			* decrement D2
	CMP	#14,D2			* is it first byte
	BEQ	excep_serial_send_excep	* if so send exception number
	MOVE.B	(A7)+,D3		* get next byte of stack frame
	MOVE.B	D3,ACIA_TR		* transmit it
	BRA	excep_time_loop
excep_serial_send_excep
	MOVE.B	D4,ACIA_TR		* transmit exception number
	BRA	excep_time_loop

	ORG	trap_code

trap					* Temporary code to handle TRAPs
	RTE				* Simply return

trap0                                   * Basic operating system support
					* D0 contains the number of
					* the routine to call
	CMP.B	#OS_Reset,D0		* OS_Reset
	BEQ	OS_Reset_Code		*
	CMP.B	#OS_Stop,D0		* OS_Stop
	BEQ	OS_Stop_Code		*
	RTE				* Unknown TRAP #0

trap15					* Handle hardware accesses
					* All are passed through here,
					* so that the same code will work
					* on different systems
					* D0 is the number of the routine
					* to be called - bits 8-15 signify
					* number of device being accessed.
	CMP.W	#Hardware_RTC_Read,D0
	BEQ	Hardware_RTC_Read_Code	* access real time clock
	CMP.W	#Hardware_RTC_Write,D0
	BEQ	Hardware_RTC_Write_Code	* access real time clock
	RTE				* Unknown TRAP #0

OS_Reset_Code				* Go into SVC mode and do a reset
	RESET
	RTE				* For completeness - will never get
					* here

OS_Stop_Code				* Go into SVC mode and halt
	STOP #$0			* STOP in user mode - allow all IRQs
	Rte				* For completeness - will never get
					* here

Hardware_RTC_Read_Code			* on entry D1 = register number
					*               to read
					* on exit  D0 = register value

	MOVE.B	#$31,PIA_CRA		* select PIA DDRA
	MOVE.B	#$FF,PIA_DDRA		* make Port A outputs
	MOVE.B	#$04,PIA_CRB		* select PIA Periph Reg B
	MOVE.B	#$35,PIA_CRA		* select PIA Periph Reg A (keep CA1
					* interrupts enabled)
	MOVE.B	D1,PIA_PRA		* output address on Port A
	MOVE.B	#$F3,PIA_PRB		* other bits high, enable chip,
					* assert AS, read mode
	MOVE.B	#$F1,PIA_PRB		* negate AS - must be 135ns between
					* instructions for this to work
					* without an extra delay
	MOVE.B	#$31,PIA_CRA		* select DDRA
	MOVE.B	#$00,PIA_DDRA		* make port A inputs
	MOVE.B	#$35,PIA_CRA		* select Periph Reg A
	MOVE.B	#$F5,PIA_DDRB		* other bits high, enable chip,
					* read mode, assert DS
	MOVE.B	PIA_PRA,D0		* read data from Port A into D0
	MOVE.B	#$F9,PIA_PRB		* other bits high, disable RTC,read
	RTE				* return from exception

Hardware_RTC_Write_Code			* on entry D1 = register number
					*               to write
					*          D2 = value to write
	MOVE.B	#$31,PIA_CRA		* select PIA DDRA
	MOVE.B	#$FF,PIA_DDRA		* make Port A outputs
	MOVE.B	#$04,PIA_CRB		* select PIA Periph Reg B
	MOVE.B	#$35,PIA_CRA		* select PIA Periph Reg A (keep CA1
					* interrupts enabled)
	MOVE.B	D1,PIA_PRA		* output address on Port A
	MOVE.B	#$F2,PIA_PRB		* other bits high, enable chip,
					* assert AS, write mode
	MOVE.B	#$F0,PIA_PRB		* negate AS - must be 135ns between
					* instructions for this to work
					* without an extra delay
	MOVE.B	#$31,PIA_CRA		* select DDRA
	MOVE.B	#$FF,PIA_DDRA		* make port A outputs
	MOVE.B	#$35,PIA_CRA		* select Periph Reg A
	MOVE.B	D2,PIA_PRA		* write data from D2 to Port A
	MOVE.B	#$F4,PIA_PRB		* other bits high, enable chip,
					* write mode, assert DS
	MOVE.B	#$F9,PIA_PRB		* other bits high, disable RTC, read
	RTE				* return from exception

